;
; SAME GAME for SHARP POCKET COMPUTER PC-G850/S/V
;

.include "same.h"

SPACE = 0
STONE1 = 1
STONE2 = 2
STONE3 = 3
STONE4 = 4
STONE5 = 5
WALL = 7

.area _CODE

;
; Q[C
;
main:
	; ŏ̎s?
	ld HL, #hiscore + 1
	ld A, (HL)
	inc A
	jr Z, main_init

main_start:
	; L[𗣂܂ő҂
	call 0xbe53
	jr C, main_start
	call cls

main_loop:
	; ʂXV
	call unselect_stone
	ld A, (#cursor_loc)
	call select_stone
	call update_screen

main_getkey:
	; BREAKL[ꂽ?
	in A, (#0x1f)
	rlca
	jp C, cls

	; SHIFT+Qꂽ?
	call 0xbe53
	cp #0x82
	jr Z, main_restart

main_move:
	; J[\\
	ld HL, #pat_cursor
	in A, (#0x14)
	rrca
	jr C, main_skip
	ld A, (#cursor_loc)
	call getmap_pat
main_skip:
	ld A, (#cursor_loc)
	call putpat

	; J[\𓮂
	call move_cursor
	jr C, main_loop

	; ΂菜
	call move_remove
	jr NC, main_getkey
	
	; Q[I`FbN
	call check_end
	jr C, main_loop

	; Q[I
	ld DE, #0x0208
	ld B, #9
	ld HL, #text_gameover
	call 0xbff1
	call 0xbcfd

	; nCXRA?
	ld HL, (#hiscore)
	ex DE, HL
	ld HL, (#score)
	or A
	sbc HL, DE
	jr C, main_restart

	; nCXRA
	ld HL, (#score)
	ld (#hiscore), HL

main_restart:
	; Q[
	call init_game
	jr main_start

main_init:
	; ō_
	ld (HL), #0

	; 
	ld HL, (#0x7a9c)
	call srand
	jr main_restart

text_gameover:
	.ascii /GAME OVER/

;
; Q[
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
init_game:
	ld HL, #map
	ld B, #HEIGHT
init_game_loop2:
	push BC
	ld B, #WIDTH - 1
init_game_loop:
	; _Ȑ΂𓾂
	call rand
	rlca
	rlca
	rlca
	rlca
	rlca
	and #0x07
	or A
	jr Z, init_game_loop
	cp #6
	jr NC, init_game_loop

	; ΂u
	ld (HL), A
	inc HL
	djnz init_game_loop

	; ǂ𒵂΂
	inc HL
	pop BC
	djnz init_game_loop2

	; _
	ld HL, #0
	ld (#score), HL

	; J[\ʒu
	xor A
	ld (#cursor_loc), A
	out (#0x11), A
	ret

;
; ΂Ȃ`FbN
;
; 
; Ȃ
;
; o
; CY:΂, NC:Ȃ
; A,BC,DE,HL:j
;
check_end:
	ld B, #0
check_end_loop:
	ld A, B
	inc B
	scf
	ccf
	ret Z
	push BC
	call select_stone
	pop BC
	jr Z, check_end_loop

	call unselect_stone
	scf
	ret

;
; ΂菜
;
; 
; A:ʒu
;
; o
; CY:΂菜, NC:΂菜Ȃ
; A,BC,DE,HL:j
;
remove_stone:
	; ΂I
	call unselect_stone
	call select_stone
	scf
	ccf
	ret Z

	; _Z
	sub #2
	ld D, A
	call mulu8
	ld DE, (#score)
	add HL, DE
	ld (#score), HL

; ΂菜
remove_stone_remove:
	ld B, #0
	ld HL, #map

remove_stone_remove_loop:
	; Iꂽ΂?
	ld A, (HL)
	and #0x08
	jr Z, remove_stone_remove_skip
	
	; 󔒂ɂ
	ld (HL), #SPACE

remove_stone_remove_skip:
	inc HL
	djnz remove_stone_remove_loop

; ΂𗎂Ƃ
remove_stone_fall_redo:
	call update_screen
	ld BC, #0
	ld HL, #map

remove_stone_fall_loop:
	push HL

	; 󔒂?
	inc (HL)
	dec (HL)
	jr NZ, remove_stone_fall_skip
	ld D, H
	ld E, L

	; オǂłȂ?
	ld A, #WIDTH
	call add_hl_a
	ld A, (HL)
	cp #WALL
	jr Z, remove_stone_fall_skip
	; オ󔒂łȂ?
	inc A
	dec A
	jr Z, remove_stone_fall_skip

	; ΂𗎂Ƃ
	ld (HL), #SPACE
	ex DE, HL
	ld (HL), A
	inc C

remove_stone_fall_skip:
	pop HL
	inc HL
	djnz remove_stone_fall_loop
	inc C
	dec C
	jr NZ, remove_stone_fall_redo

; ΂Eɓ
remove_stone_right_redo:
	call update_screen
	ld HL, #map
	ld BC, #(WIDTH - 2) * 0x100

remove_stone_right_loop:
	; 󔒂?
	push HL
	inc (HL)
	dec (HL)
	jr NZ, remove_stone_right_skip
	; Eׂ󔒂?
	inc HL
	inc (HL)
	dec (HL)
	dec HL
	jr Z, remove_stone_right_skip

	; ΂ɓ
	inc C
	push BC
	ld B, #HEIGHT
remove_stone_right_loop2:
	inc HL
	ld A, (HL)
	ld (HL), #SPACE
	dec HL
	ld (HL), A
	ld A, #WIDTH
	call add_hl_a
	djnz remove_stone_right_loop2
	pop BC

remove_stone_right_skip:
	pop HL
	inc HL
	djnz remove_stone_right_loop
	inc C
	dec C
	jr NZ, remove_stone_right_redo

	scf
	ret

;
; ΂I
;
; 
; A:ʒu
;
; o
; A:I΂̐
; Z:΂菜Ȃ, NZ:菜
; F,BC,DE,HL,AF':j
;
select_stone:
	ex AF, AF'
	ld A, #1
	ex AF, AF'

	; ΂𓾂
	call getmap
	cp #SPACE
	ret Z
	cp #WALL
	ret Z
	ld D, A

	push HL

	; ΂IԂɂ
	or #0x08
	ld E, A
	ld (HL), A

select_stone_loop2:
	ld BC, #0
select_stone_loop:
	; Iꂽ΂Ɠނ̐΂?
	ld A, B
	call getmap
	cp D
	jr NZ, select_stone_skip

	; ɑIꂽ΂邩?
	ld A, B
	sub #WIDTH
	call getmap
	cp E
	jr Z, select_stone_select
	
	; ɑIꂽ΂邩?
	ld A, B
	dec A
	call getmap
	cp E
	jr Z, select_stone_select

	; EɑIꂽ΂邩?
	ld A, B
	inc A
	call getmap
	cp E
	jr Z, select_stone_select

	; ɑIꂽ΂邩?
	ld A, B
	add #WIDTH
	call getmap
	cp E
	jr Z, select_stone_select

select_stone_skip:
	djnz select_stone_loop

	; ΂I?
	inc C
	dec C
	jr NZ, select_stone_loop2

	pop HL

	ex AF, AF'
	cp #1
	ret NZ

	res 3, (HL)
	ret

select_stone_select:
	; ΂I
	ld A, B
	call getmap
	or #0x08
	ld (HL), A

	ex AF, AF'
	inc A
	ex AF, AF'
	inc C
	jr select_stone_skip

;
; ΂Iɂ
;
; 
; Ȃ
;
; o
; BC,HL:j
;
unselect_stone:
	push AF

	ld B, #0
unselect_stone_loop:
	ld A, B
	call getmap
	and #0x07
	ld (HL), A
	djnz unselect_stone_loop

	pop AF
	ret

;
; ΂菜
;
; 
; (#cursor_loc):J[\ʒu
;
; o
; CY:΂菜, NC:菜Ȃ
; A,BC,DE,HL:j
;
move_remove:
	; SPACEL[ꂽ?
	call 0xbe53
	cp #0x1e
	scf
	ccf
	ret NZ

	; ΂菜
	ld A, (#cursor_loc)
	jp remove_stone

;
; J[\𓮂
;
; 
; (#cursor_loc):J[\ʒu
;
; o
; (#cursor_loc):J[\ʒu
; A:J[\ʒu
; CY:J[\, NC:Ȃ
; BC,DE,HL:j
;
move_cursor:
	call 0xbe53

	ld B, #-WIDTH
	cp #0x2d
	jr Z, move_cursor_move

	ld B, #-1
	cp #0x34
	jr Z, move_cursor_move

	ld B, #1
	cp #0x36
	jr Z, move_cursor_move
	
	ld B, #WIDTH
	cp #0x3d
	jr Z, move_cursor_move

move_cursor_not_move:
	; LȃL[Ȃ
	or A
	ret

move_cursor_move:
	; J[\𓮂
	ld A, (#cursor_loc)
	add B
	ld B, A
	
	; ǂȂ߂
	call getmap
	cp #WALL
	jr Z, move_cursor_not_move

	; J[\ʒu
	ld A, B
	ld (#cursor_loc), A
	scf
	ret

;
; ʂXV
;
; 
; Ȃ
;
; o
; AF,BC:j
;
update_screen:
	xor A

	; ΂\
update_screen_loop:
	call getmap_pat
	call putpat
	cp #WIDTH * HEIGHT
	jr NZ, update_screen_loop

	; _\
	ld B, #6
	ld DE, #0x0501
	ld HL, #text_score
	call 0xbff1
	ld DE, #0x0507
	ld HL, (#score)
	call print_hl

	; ō_\
	ld B, #3
	ld DE, #0x050f
	ld HL, #text_hiscore
	call 0xbff1
	ld DE, #0x0512
	ld HL, (#hiscore)
	jp print_hl

text_hiscore:
	.ascii /HI:/
text_score:
	.ascii /SCORE:/

;
; ΂̃p^[𓾂
;
; 
; A:ʒu
;
; o
; HL:p^[̃AhX
; B:j
;
getmap_pat:
	push AF

	call getmap
	ld B, A
	add A
	add A
	add B
	add B
	ld HL, #pat
	call add_hl_a

	pop AF
	ret

;
; ΂𓾂
;
; 
; A:ʒu
;
; o
; A:
; HL:YAhX
; F:j
;
getmap:
	ld HL, #map
	call add_hl_a
	ld A, (HL)
	ret

;
; l\
;
; 
; DE:W
; HL:l
;
; o
; AF,BC,DE,HL:j
;
print_hl:
	push DE
	ld DE, #score_buf
	ld BC, #10000
	call print_hl1
	ld BC, #1000
	call print_hl1
	ld BC, #100
	call print_hl1
	ld BC, #10
	call print_hl1
	ld BC, #1
	call print_hl1
	pop DE

	ld HL, #score_buf
	ld B, #5
	jp 0xbff1

print_hl1:
	ld A, #-1
print_hl1_loop:
	inc A
	or A
	sbc HL, BC
	jr NC, print_hl1_loop
	add HL, BC

	add #0x30
	ld (DE), A
	inc DE
	ret

;
; HL = HL + A
;
; 
; HL,A:l
;
; o
; HL:vZ
;
add_hl_a:
	push BC

	ld B, #0
	ld C, A
	add HL, BC

	pop BC
	ret

; J[\ʒu
cursor_loc:
	.db 0x00
; _
score:
	.dw 0
; ō_
hiscore:
	.dw 0xff00
; _\obt@
score_buf:
	.db 0, 0, 0, 0, 0

; p^[
pat:
pat_space:
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
pat_stone1:
	.db 0x77, 0x55, 0x55, 0x55, 0x77, 0x00
pat_stone2:
	.db 0x77, 0x77, 0x77, 0x77, 0x77, 0x00
pat_stone3:
	.db 0x55, 0x22, 0x55, 0x22, 0x55, 0x00
pat_stone4:
	.db 0x44, 0x66, 0x55, 0x66, 0x44, 0x00
pat_stone5:
	.db 0x11, 0x33, 0x77, 0x33, 0x11, 0x00
pat_cursor:
	.db 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
pat_wall:
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
pat_rev:
	.db 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
pat_stone1rev:
	.db 0x88, 0xaa, 0xaa, 0xaa, 0x88, 0xff
pat_stone2rev:
	.db 0x88, 0x88, 0x88, 0x88, 0x88, 0xff
pat_stone3rev:
	.db 0xaa, 0xdd, 0xaa, 0xdd, 0xaa, 0xff
pat_stone4rev:
	.db 0xbb, 0x99, 0xaa, 0x99, 0xbb, 0xff
pat_stone5rev:
	.db 0xee, 0xcc, 0x88, 0xcc, 0xee, 0xff

; }bv
map:
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL

; eof
